/*
 * CS 4481 Compilers
 * Project 1 - scanner part 1
 *
 * This file contains the method runTests(). You will uncomment tests
 * as you develop your scanner code
 */
package scanner;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;

/**
 *
 * @author edwajohn
 */
public class Main {

  public static void main(String[] args)
          throws FileNotFoundException, IOException {
    if (args.length > 0) {
      scanInputFile(args[0], args[1]);
    } else {
      int failures = runTests();
      System.exit(failures);
    }
  }

  public static int runTests() throws FileNotFoundException, IOException {
    Tests tests = new Tests();

    // TODO: uncomment tests as you develop code

    //------------------------------------------------------------
    // Test register.table reading, table building and token
    // parsing. These tests should pass once you have the Scanner
    // constructor implemented.
    //------------------------------------------------------------

//    String tableFile = "data/register.table";
//    TableParser tableParser = new TableParser(tableFile);
//    Scanner scanner = new Scanner(tableParser);
//
//    tests.test(scanner.testCategory('r', "register"));
//    tests.test(scanner.testCategory('3', "digit"));
//    tests.test(scanner.testCategory('8', "digit"));
//    tests.test(scanner.testCategory(' ', "whitespace"));
//
//    tests.test(scanner.testTransition("s0", "register", "s1"));
//    tests.test(scanner.testTransition("s1", "digit", "s2"));
//    tests.test(scanner.testTransition("s3", "whitespace", "s3"));
//
//    tests.test(scanner.testTokenType("s2", "register"));
//    tests.test(scanner.testTokenType("s3", "ignore"));

    //------------------------------------------------------------
    // The following tests should pass once you have
    // Scanner.parseToken() implemented.
    //------------------------------------------------------------
    {
      //------------------------------------------------------------
      // Test input test.reg
      //------------------------------------------------------------

//      ScanStream ss = getDataStream("data/test.reg");
//
//      Token t;
//      t = scanner.parseToken(ss);
//      tests.test(t.test("register", "r302"));
//      t = scanner.parseToken(ss);
//      tests.test(t.test("ignore"));
//      t = scanner.parseToken(ss);
//      tests.test(t.test("register", "r02"));
//      t = scanner.parseToken(ss);
//      tests.test(t.test("ignore"));
//      t = scanner.parseToken(ss);
//      tests.test(t.test("register", "r233987"));
    }

    {
      //------------------------------------------------------------
      // Test input err1.reg
      //------------------------------------------------------------

//      ScanStream ss = getDataStream("data/err1.reg");
//      Token t = scanner.parseToken(ss);
//      tests.test(t == null, "Expected lexical error on " + ss.next());
    }

    {
      //------------------------------------------------------------
      // Test input err2.reg
      //------------------------------------------------------------

//      ScanStream ss = getDataStream("data/err2.reg");
//      Token t = scanner.parseToken(ss);
//      tests.test(t == null, "Expected lexical error on " + ss.next());
    }

    {
      //------------------------------------------------------------
      // Test input err3.reg
      //------------------------------------------------------------

//      ScanStream ss = getDataStream("data/err3.reg");
//      Token t;
//      t = scanner.parseToken(ss);
//      tests.test(t.test("register", "r33"));
//      t = scanner.parseToken(ss);
//      tests.test(t == null, "Expected lexical error on " + ss.next());
    }

    //------------------------------------------------------------
    // Output number of tests that succeeded
    //------------------------------------------------------------
    System.out.println(tests.getSuccesses() + "/" + tests.getN()
            + " tests succeeded");
    return tests.getFailures();
  }

  private static ScanStream getDataStream(String testFile) throws IOException {
    File file = new File(testFile);
    FileInputStream fis = new FileInputStream(file);
    byte[] data = new byte[(int) file.length()];
    fis.read(data);
    fis.close();
    ScanStream ss = new ScanStream(data);
    return ss;
  }

  public static void scanInputFile(String tableFile, String testFile)
          throws FileNotFoundException, IOException {
    TableParser tableParser = new TableParser(tableFile);

    File file = new File(testFile);
    FileInputStream fis = new FileInputStream(file);
    byte[] data = new byte[(int) file.length()];
    fis.read(data);
    fis.close();

    PrintWriter writer = new PrintWriter(testFile + ".out", "UTF-8");

    Scanner scanner = new Scanner(tableParser);
    ScanStream ss = new ScanStream(data);
    Token t;
    do {
      t = scanner.parseToken(ss);
      if (t == null) {
        System.out.println("Lexical error: " + ss.next());
        ss.rollback();
        writer.println("Lexical error: " + ss.next());
      } else if (!t.getType().equals("ignore")) {
        System.out.println(t.toString());
        writer.println(t.toString());
      }
    } while (t != null && !ss.eof());

    writer.close();
  }


}
