package scanner;

import java.util.HashMap;
import java.util.Stack;

/**
 *
 * @author edwajohn
 */
public class Scanner {

  //------------------------------------------------------------
  // Data members
  //------------------------------------------------------------

  // Category table
  final HashMap<Character, String> catMap = new HashMap<>();
  // Transition table
  final HashMap<State, HashMap<String, State>> tt = new HashMap<>();
  // Token type table
  final HashMap<State, String> tokenTypes = new HashMap<>();
  // Utility
  final HashMap<String, State> name2state = new HashMap<>();
  // Start state
  private State s0;

  //------------------------------------------------------------
  // TODO: build your tables in the constructor
  //------------------------------------------------------------

  public Scanner(TableParser tableParser) {
    // TODO: starting with the skeleton code below, build the
    // classifer, transition and token type tables.

    for (TableParser.CharCat cat : tableParser.getClassifier()) {
      System.out.println("Character " + cat.getC() + " is of category "
              + cat.getCategory());
    }
    for (TableParser.Transition t : tableParser.getTransitions()) {
      System.out.println(t.getFromState() + " -- " + t.getCategory()
              + " --> " + t.getToState());
    }
    for (TableParser.TokenType tt : tableParser.getTokens()) {
      System.out.println("State " + tt.getState()
              + " accepts with the lexeme being of type " + tt.getType());
    }

  }

  //------------------------------------------------------------
  // TODO: implement parseToken
  //------------------------------------------------------------

  public Token parseToken(ScanStream ss) {
    // TODO: parse a single token. This is an implementation of the algorithm
    // in figure 2.14 of the book. You may *not* use TableParser in this
    // function. Return null if there is a lexical error.
    return null;
  }

  //------------------------------------------------------------
  // Test utility methods
  //------------------------------------------------------------

  public boolean testCategory(Character c, String targetCat) {
    String cat = catMap.get(c);
    if (!cat.equals(targetCat)) {
      System.err.println("Unexpected category for character " + c
              + ": " + cat + ". Expected " + targetCat);
      return false;
    }
    return true;
  }

  public boolean testTransition(String state, String type, String targetState) {
    State newState = tt.get(name2state.get(state)).get(type);
    if (!newState.toString().equals(targetState)) {
      System.err.println("Unexpected transition for state " + state
              + " on type " + type + ": " + newState + ". Expected "
              + targetState);
      return false;
    }
    return true;
  }

  public boolean testTokenType(String state, String targetType) {
    String type = tokenTypes.get(name2state.get(state));
    if (!type.equals(targetType)) {
      System.err.println("Unexpected type for state " + state
              + ": " + type + ". Expected " + targetType);
      return false;
    }
    return true;
  }

}
