/*
 * DO NOT MODIFY THIS FILE
 */
package scanner;

/**
 *
 * @author edwajohn
 */
public class Token {

  private final String type;
  private final String lexeme;

  public Token(String type, String lexeme) {
    this.type = type;
    this.lexeme = lexeme;
  }

  public String toString() {
    return type + ": " + lexeme;
  }

  public String getType() {
    return type;
  }

  public String getLexeme() {
    return lexeme;
  }

  public boolean test(String targetType) {
    return test(targetType, "");
  }

  public boolean test(String targetType, String targetLexeme) {
    boolean b = targetType.equals(type);
    if (!b) {
      System.err.println("Unexpected type " + type + ". Expected "
              + targetType);
      return false;
    }
    b = targetLexeme.equals(lexeme) || type.equals("ignore");
    if (!b) {
      System.err.println("Unexpected lexeme " + lexeme + ". Expected "
              + targetLexeme);
      return false;
    }
    return true;
  }

  public static boolean testNext(
      String targetType, String targetLexeme, Scanner scanner, ScanStream ss) {
    Token t = scanner.parseToken(ss);
    // Skip whitespace and comments
    while (t.getType().equals("ignore")) {
      t = scanner.parseToken(ss);
    }
    return t.test(targetType, targetLexeme);
  }

}
